#!/usr/bin/env python3

"""
based on a project from CS 106A at Stanford
"""

###
# Parsing tweets
###


def parse_user(tweet):
    """
    Parse the username in a tweet. Given a tweet like '@bob: hello #woot', returns
    the user '@bob' or '' if no user is found.

    :param tweet: a tweet
    :return: a username
    >>> parse_user('@jonathan: tweet')
    '@jonathan'
    >>> parse_user('@ThisIsATest: #oh #yeah')
    '@ThisIsATest'
    >>> parse_user('meh')
    ''
    """
    pass


def parse_tag(tweet):
    """
    Parse the tag in a tweet. Given a tweet like '@bob: hello #woot', returns
    the user '@bob' or '' if no user is found.
    :param tweet: a tweet
    :return: a tag
    """
    pass

###
# Building a user_tags dictionary
###


def add_tweet(user_tags, tweet):
    """
    Given a user_tags dict and a tweet, parse out the user and tags,
    and add those counts to the user_tags dict. This function does not
    return anything because the dict is directly modified.

    If no user exists in the tweet, don't do anything. Likewise, if no
    tag exists, don't do anything.

    Note: call the parse_tags(tweet) and parse_user(tweet) functions to pull
    the parts out of the tweet.

    :param user_tags: a dictionary of all the tags and their count, by user
    :param tweet: a tweet
    >>> test_dict = {}
    >>> add_tweet(test_dict, '@alice: #apple')
    >>> test_dict
    {'@alice': {'#apple': 1}}
    >>> add_tweet(test_dict, '@alice: #banana')
    >>> test_dict
    {'@alice': {'#apple': 1, '#banana': 1}}
    >>> test_dict = {'@alice': {'#apple': 1, '#banana': 1}}
    >>> add_tweet(test_dict, '@alice: #banana')
    >>> test_dict
    {'@alice': {'#apple': 1, '#banana': 2}}
    >>> test_dict = {'@alice': {'#apple': 1, '#banana': 2}}
    >>> add_tweet(test_dict, '@bob: #apple')
    >>> test_dict
    {'@alice': {'#apple': 1, '#banana': 2}, '@bob': {'#apple': 1}}
    """
    pass


def parse_tweets(filename):
    """
    Given a file of tweets, 1 per line, build and return a user_tags dict
    of all the tweet data.

    :param filename: a file with tweets
    :return: a dictionary that has usernames as keys and a dictionary of counts
      for tags as the values

    >>> parse_tweets('small-tweets.txt')
    {'@BarackObama': {'#SOTU': 3, '#BigBlockOfCheeseDay': 1}, '@GonzalezSarahA': {'#education': 1}}
    """
    pass


def print_users(user_tags):
    """
    This function takes a user_tags dictionary and prints out all the users,
    sorted alphabetically.

    :param user_tags: a dictionary of users and the tags they use
    >>> print_users({'@GonzalezSarahA': {'#education': 1}, '@BarackObama': {'#SOTU': 3, '#BigBlockOfCheeseDay': 1}})
    @BarackObama
    @GonzalezSarahA
    """
    pass


def print_counts(counts):
    """
    This function takes a dictionary of tag counts that looks like:

    {'#zebra': 12, '#apple': 13, '#boat': 1}

    It prints the tags in order, so it looks like:

     #apple -> 13
     #boat -> 1
     #zebra -> 12

    :param counts: a dictionary of counts
    >>> print_counts({'#zebra': 12, '#apple': 13, '#boat': 1})
     #apple -> 13
     #boat -> 1
     #zebra -> 12
    """
    pass


def print_user(user_tags, user):
    """
    This function takes a dictionary of users and the tags they use, as well as a
    user, and prints out the tags and counts for just that user.

    :param user_tags: a dictionary of users and the tags they use
    :param user: a username
    >>> print_user({'@BarackObama': {'#SOTU': 3, '#BigBlockOfCheeseDay': 1}, '@GonzalezSarahA': {'#education': 1}},'@BarackObama')
    @BarackObama
     #BigBlockOfCheeseDay -> 1
     #SOTU -> 3
    """
    pass


def print_users_and_counts(user_tags):
    """
    This function takes a dictionary of users and the tags they use, and prints
    out the users and tag counts for each user.

    :param user_tags: a dictionary of users and tags
    >>> print_users_and_counts({'@BarackObama': {'#SOTU': 3, '#BigBlockOfCheeseDay': 1}, '@GonzalezSarahA': {'#education': 1}})
    @BarackObama
     #BigBlockOfCheeseDay -> 1
     #SOTU -> 3
    @GonzalezSarahA
     #education -> 1
    """
    pass

###
# Counting Tags
###


def tag_counts(user_tags):
    """
    Given a user_tags dictionary, create new dictionary that sum up the
    tag counts across all users. This dictionary has a key for each tag,
    and the value for this key is the sum of that tag's count across all users.
    Return this dictionary
    :param user_tags: a dictionary of users and a count of their tags
    :return: a dictionary that sums all the tag counts
    >>> tag_counts({'@alice': {'#apple': 1, '#banana': 2}, '@bob': {'#apple': 1}})
    {'#apple': 2, '#banana': 2}
    """
    pass


def print_tag_counts(user_tags):
    """
    This function takes a dictionary of users and the tags they use and
    prints out the total counts for each tag

    :param user_tags: a dictionary of users and the tags they use
    >>> print_tag_counts({'@BarackObama': {'#SOTU': 3, '#BigBlockOfCheeseDay': 1}, '@GonzalezSarahA': {'#education': 1}})
     #BigBlockOfCheeseDay -> 1
     #SOTU -> 3
     #education -> 1
    >>> print_tag_counts({'@alice': {'#apple': 1, '#banana': 2}, '@bob': {'#apple': 1}})
     #apple -> 2
     #banana -> 2
    """
    pass


###
# Top Tweets
###


def top_tag(user_tags):
    """
    Find the most popular tag across all users

    :param user_tags: a dictionary of users and a count of their tags
    :return: a tuple of (tag, count)
    >>> top_tag({'@alice': {'#apple': 1, '#banana': 2}, '@bob': {'#apple': 2}})
    ('#apple', 3)
    """
    pass


def user_top_tag(user_tags, user):
    """
    find the most popular tag for a specific user

    :param user_tags: a dictionary of users and a count of their tags
    :param user: a user
    :return: a tuple of (tag, count)
    >>> user_top_tag({'@alice': {'#apple': 1, '#banana': 2}, '@bob': {'#apple': 2}},'@alice')
    ('#banana', 2)
    >>> user_top_tag({'@alice': {'#apple': 1, '#banana': 2}, '@bob': {'#apple': 2}},'@bob')
    ('#apple', 2)
    """
    pass


def print_top_tag(user_tags):
    """
    This function takes a dictionary of users and the tags they use and prints out the
    most popular tag.

    :param user_tags: a dictionary of users and the tags they use
    >>> print_top_tag({'@alice': {'#apple': 1, '#banana': 2}, '@bob': {'#apple': 2}})
     #apple -> 3
    """
    pass


def print_user_top_tag(user_tags, user):
    """
    This function takes a dictionary of users and the tags they use and prints out the
    most popular tag for the given user.

    :param user_tags: a dictionary of users and the tags they use
    :param user: a username
    >>> print_user_top_tag({'@alice': {'#apple': 1, '#banana': 2}, '@bob': {'#apple': 2}}, '@alice')
     #banana -> 2
    >>> print_user_top_tag({'@alice': {'#apple': 1, '#banana': 2}, '@bob': {'#apple': 2}}, '@bob')
     #apple -> 2
    """
    pass


"""
You don't need to modify any of the code below here.
"""


def main():
    import argparse

    # setup the argument parser
    parser = argparse.ArgumentParser(description="Tweet Parser")
    parser.add_argument('--users', action='store_true', help='print the usernames')
    parser.add_argument('--user', type=str, default="", help='print data for a particular user')
    parser.add_argument('--tags', action='store_true', help='prints tag counts for each tag')
    parser.add_argument('--top', action='store_true', help='prints top tag across all users')
    parser.add_argument('--user-top', type=str, default="", help='prints top tag for a particular user')
    parser.add_argument('filename', type=str, help='filename with tweets')

    # parse the command line arguments
    args = parser.parse_args()

    # parse the tweets
    user_tags = parse_tweets(args.filename)

    # handle --users
    if args.users:
        print_users(user_tags)
        return

    # handle --user
    if args.user:
        print_user(user_tags, args.user)
        return

    # handle --tags
    if args.tags:
        print_tag_counts(user_tags)
        return

    # handle --top
    if args.top:
        print_top_tag(user_tags)
        return

    # handle --user-top
    if args.user_top:
        print_user_top_tag(user_tags, args.user_top)
        return

    # default
    print_users_and_counts(user_tags)


if __name__ == '__main__':
    main()
